
; FREQDECA.ASM

; Ez a program a hat mr?frekvencin kvl 1 Hz-es ngyszgjel el?lltsra
; is kpes. Kivlasztshoz a C port sszes bemenett szabadon kell hagyni.

    LIST P=PIC16F1614
    #include <p16f1614.inc>
    list    r=dec

; MPLAB X has a feature which generates configuration bits source code.  Go to
; Window > PIC Memory Views > Configuration Bits.  Configure each field as
; needed and select 'Generate Source Code to Output'.  The resulting code which
; appears in the 'Output Window' > 'Config Bits Source' tab may be copied
; below. DONE!
    
; CONFIG1= 0xFFBF
 __CONFIG _CONFIG1, _FOSC_ECH & _PWRTE_OFF & _MCLRE_OFF & _CP_OFF & _BOREN_ON & _CLKOUTEN_OFF
; CONFIG2= 0xDDFF
 __CONFIG _CONFIG2, _WRT_OFF & _PPS1WAY_OFF & _ZCD_OFF & _PLLEN_OFF & _STVREN_OFF & _BORV_LO & _LPBOR_OFF & _LVP_OFF
; CONFIG3= 0xFF9F
 __CONFIG _CONFIG3, _WDTCPS_WDTCPS1F & _WDTE_OFF & _WDTCWS_WDTCWSSW & _WDTCCS_SWC

    cblock	0x70
   oldc
   temp
    endc
 
snz	macro
	btfsc status,z
	endm
sz	macro
	btfss status,z
	endm
sb	macro file,bit
	btfss file,bit
	endm
snb	macro file,bit
	btfsc file,bit
	endm

    org	    0x0000            
    GOTO    START         

    org	    0x0004          
    RETFIE
    
START
    BANKSEL LATA
    clrf    LATA
    BANKSEL TRISA
    movlw   39h
    movwf   TRISA
    movlw   3fh
    movwf   TRISC
    bcf	OPTION_REG,7
    banksel WPUA
    movlw   3bh
    movwf   WPUA
    banksel ANSELA
    clrf    ANSELC
    BANKSEL	RA2PPS
    movlw	4
    movwf	RA2PPS
    
    BANKSEL CLC1GLS0
    movlw	H'02'
    movwf	CLC1GLS0
    movlw	H'08'
    movwf	CLC1GLS1
    movlw	H'00'
    movwf	CLC1GLS2
    movlw	H'00'
    movwf	CLC1GLS3
    movlw	H'13'
    movwf	CLC1SEL0
    movlw	H'04'
    movwf	CLC1SEL1
    movlw	H'00'
    movwf	CLC1SEL2
    movlw	H'00'
    movwf	CLC1SEL3
    movlw	H'02'
    movwf	CLC1POL
    movlw	H'84'
    movwf	CLC1CON
    BANKSEL	PORTA
    call	freki
    movlw	80h
    movwf	SMT1CON0
    clrf	SMT1CLK
    clrf	SMT1SIG
    movlw	80h
    movwf	SMT1CON1
   
main
    banksel	portc
    movf	portc,w
    xorwf	oldc,w
    sz
    call	freki
    movf	SMT1STAT,W
    movwf	temp
    banksel	LATA
    sb		temp,2
    bcf		lata,1
    snb		temp,2
    bsf		lata,1
    goto	main
	
freki
	movf	portc,w
	movwf	oldc
	banksel	smt1con0
	sb	oldc,5
	goto	f10
	sb	oldc,4
	goto	f100
	sb	oldc,3
	goto	f1k
	sb	oldc,2
	goto	f10k
	sb	oldc,1
	goto	fM1
	sb	oldc,0
	goto	f1M
	goto	f1
f1M
	clrf	smt1pru
	clrf	smt1prh
	movlw	9
	movwf	smt1prl
	return
fM1
	clrf	smt1pru
	clrf	smt1prh
	movlw	99
	movwf	smt1prl
	return
f10k
	clrf	smt1pru
	movlw	high 999
	movwf	smt1prh
	movlw	low 999
	movwf	smt1prl
	return
f1k
	clrf	smt1pru
	movlw	high 9999
	movwf	smt1prh
	movlw	low 9999
	movwf	smt1prl
	return
f100
	movlw	upper 99999
	movwf	smt1pru
	movlw	high 99999
	movwf	smt1prh
	movlw	low 99999
	movwf	smt1prl
	return
f10
	movlw	upper 999999
	movwf	smt1pru
	movlw	high 999999
	movwf	smt1prh
	movlw	low 999999
	movwf	smt1prl
	return
f1
	movlw	upper 9999999
	movwf	smt1pru
	movlw	high 9999999
	movwf	smt1prh
	movlw	low 9999999
	movwf	smt1prl
	return
	
    END
