; lcmeter.asm: Az LC mr hatfrekis ngyszggenertora. A hrom gyors
; frekvencia PWM, a hrom lass megszaktsos. A kapcsol felfel
; tekerse nveli a frekvencit (az adott bekts mellett).
; ra: 8 MHz, kvarc, nem kalibrlt.

	list p=16F1824
	list r=dec
	#include <p16F1824.inc>
	
	__CONFIG _CONFIG1, _FOSC_HS & _WDTE_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF & _CPD_OFF & _BOREN_OFF & _CLKOUTEN_OFF & _IESO_OFF & _FCMEN_OFF
	__CONFIG _CONFIG2, _WRT_OFF & _PLLEN_Off & _STVREN_OFF & _BORV_HI & _LVP_OFF
	
	cblock	0x70
	lassit
	oszto
	oldc
	endc

#include <prlx.inc>

stc	macro
	bsf	status,c
	endm
	
	org	0
	nop
	goto	start
	org	4
	banksel	0
	bcf	pir1,tmr2if
	decfsz	lassit
	retfie
	banksel	lata
	movlw	4
	xorwf	lata
	movf	oszto,w
	movwf	lassit
	retfie
	
start
	banksel	porta
	movlw	0
	movwf	porta
	banksel	trisa
	movlw	0x3b
	movwf	trisa
	movlw	11
	banksel	wpua
	movwf	wpua
	movlw	3fh
	movwf	wpuc
	banksel	ansela
	clrf	ansela
	clrf	anselc
	banksel	option_reg
	movlw	8
	movwf	option_reg
	banksel	osccon
	movlw	70h
	movwf	osccon
	banksel	pie1
	bsf	pie1,tmr2ie
	banksel	porta
	bsf	intcon,peie
	movlw	0x3f
	movwf	oldc
		
main
	movf	portc,w
	xorwf	oldc,w
	snz
	goto	main
	bcf	intcon,gie
	banksel	ccp3con
	clrf	ccp3con
	banksel	t2con
	clrf	t2con
	banksel	0
	movf	portc,w
	movwf	oldc
	sb	oldc,5
	goto	f10
	sb	oldc,4
	goto	f100
	sb	oldc,3
	goto	f1k
	sb	oldc,2
	goto	f10k
	sb	oldc,1
	goto	fM1
	sb	oldc,0
	goto	f1M
	goto	leall
f1M
	banksel	pr2
	movlw	1
	movwf	pr2
	banksel	ccp3con
	movlw	1
	movwf	ccpr3l
	movlw	0ch
	movwf	ccp3con
	banksel	t2con
	movlw	4
	movwf	t2con
	banksel	porta
	goto	main
fM1
	banksel	pr2
	movlw	19
	movwf	pr2
	banksel	ccp3con
	movlw	10
	movwf	ccpr3l
	movlw	0ch
	movwf	ccp3con
	banksel	t2con
	movlw	4
	movwf	t2con
	banksel	porta
	goto	main
f10k
	banksel	pr2
	movlw	199
	movwf	pr2
	banksel	ccp3con
	movlw	100
	movwf	ccpr3l
	movlw	0ch
	movwf	ccp3con
	banksel	t2con
	movlw	4
	movwf	t2con
	banksel	porta
	goto	main
f1k
	banksel	pr2
	movlw	199
	movwf	pr2
	banksel	t2con
	movlw	4
	movwf	t2con
	banksel	porta
	movlw	5
	movwf	oszto
	bsf	intcon,gie
	goto	main
f100
	banksel	pr2
	movlw	199
	movwf	pr2
	banksel	t2con
	movlw	4
	movwf	t2con
	banksel	porta
	movlw	50
	movwf	oszto
	bsf	intcon,gie
	goto	main
f10
	banksel	pr2
	movlw	199
	movwf	pr2
	banksel	t2con
	movlw	4ch
	movwf	t2con	; 10-es utosztt a t2 megszaktsba!
	banksel	porta
	movlw	50
	movwf	oszto
	bsf	intcon,gie
	goto	main

leall	
	banksel	porta
	goto	main

	end	